var NAVTREE =
[
  [ "SKC", "index.html", [
    [ "The SKC Secure KMIP Client Toolkit", "index.html", [
      [ "Introduction", "index.html#skc-intro", null ],
      [ "Getting Started", "index.html#main_start", null ],
      [ "Getting Help", "index.html#skc-help", null ],
      [ "Reference Guide", "index.html#skc-refguide", null ]
    ] ],
    [ "SKC Directory Structure", "skc-dir.html", [
      [ "Overview", "skc-dir.html#skc-dir-overview", null ]
    ] ],
    [ "Building The Examples", "skc-build-examples.html", [
      [ "Overview", "skc-build-examples.html#skc-build-examples-overview", [
        [ "Building Examples On Windows", "skc-build-examples.html#skc-build-examples-windows", null ],
        [ "Building on Non-Windows", "skc-build-examples.html#skc-build-examples-non-windows", null ]
      ] ]
    ] ],
    [ "Building Your Application With SKC", "skc-building.html", [
      [ "Overview", "skc-building.html#skc-building-overview", [
        [ "Steps For Building With SKC", "skc-building.html#skc-building-steps", null ]
      ] ]
    ] ],
    [ "Loading Components", "skc-load.html", [
      [ "Overview", "skc-load.html#skc-load-overview", null ]
    ] ],
    [ "Deploying SKC", "skc-deploy.html", [
      [ "Overview", "skc-deploy.html#skc-deploy-overview", [
        [ "Language Files", "skc-deploy.html#skc-deploy-lang", null ]
      ] ]
    ] ],
    [ "SKC Redistributibles", "skc-redist.html", null ],
    [ "SKC Toolkit Examples", "skc-examples.html", [
      [ "Introduction", "skc-examples.html#skc-examples-into", null ],
      [ ".cpp Loading SKC Components", "skc-examples.html#ex-loader", null ]
    ] ],
    [ "SKC References", "skc-references.html", null ],
    [ "cfilestream.h", "common_cfilestream_h.html", null ],
    [ "cfilestream.cpp", "common_cfilestream_cpp.html", null ],
    [ "cconsolestream.h", "common_cconsolestream_h.html", null ],
    [ "cconsolestream.cpp", "common_cconsolestream_cpp.html", null ],
    [ "Release Notes", "skc-releasenotes.html", null ],
    [ "KMIP Reference Guide", "p6kmip.html", [
      [ "Introduction", "p6kmip.html#p6rkmip_intro", [
        [ "Includes", "p6kmip.html#p6rkmip_includes", null ],
        [ "Interfaces", "p6kmip.html#p6kmip_interfaces", null ],
        [ "Ease of Use", "p6kmip.html#p6kmip_easeofuse", null ],
        [ "Some Configuration Parameters", "p6kmip.html#p6rssh_config", null ],
        [ "Support for Notify and Put Operations", "p6kmip.html#p6kmip_server", null ],
        [ "Conformance", "p6kmip.html#p6kmip_conformance", null ],
        [ "Support for the Suite B Profile", "p6kmip.html#p6kmip_suiteb", null ]
      ] ]
    ] ],
    [ "KMIP Examples", "kmip_examples.html", [
      [ "KMIP Examples", "kmip_examples.html#kmip_ex_into", null ]
    ] ],
    [ "KMIP Example 1 - Basic Code Structure", "kmip_example1.html", null ],
    [ "ex-kmip-1.cpp", "kmip_example1_ex_kmip_1_cpp.html", null ],
    [ "KMIP Example 2 - Asynchronous KMIP operation", "kmip_example2.html", null ],
    [ "ex-kmip-2.cpp", "kmip_example2_ex_kmip_2_cpp.html", null ],
    [ "KMIP Example 3 - Key Wrapping", "kmip_example3.html", null ],
    [ "ex-kmip-3.cpp", "kmip_example3_ex_kmip_3_cpp.html", null ],
    [ "KMIP Example 4 - Register a symmetric key", "kmip_example4.html", null ],
    [ "ex-kmip-4.cpp", "kmip_example4_ex_kmip_4_cpp.html", null ],
    [ "KMIP Example 5 - Cllean all managed objects off of KMIP server", "kmip_example5.html", null ],
    [ "ex-kmip-5.cpp", "kmip_example5_ex_kmip_5_cpp.html", null ],
    [ "KMIP Example 6 - Notify and Put Support", "kmip_example6.html", null ],
    [ "ex-kmip-6.cpp", "kmip_example6_ex_kmip_6_cpp.html", null ],
    [ "KMIP Example 7 - Create and register asymmetric keys", "kmip_example7.html", null ],
    [ "ex-kmip-7.cpp", "kmip_example7_ex_kmip_7_cpp.html", null ],
    [ "KMIP Example 8 - KMIP server creates asymmetric keys", "kmip_example8.html", null ],
    [ "ex-kmip-8.cpp", "kmip_example8_ex_kmip_8_cpp.html", null ],
    [ "KMIP Example 9 - KMIP server creates certificate for key pair", "kmip_example9.html", null ],
    [ "ex-kmip-9.cpp", "kmip_example9_ex_kmip_9_cpp.html", null ],
    [ "KMIP Example 10 - Adding multiple attributes to a managed object", "kmip_example10.html", null ],
    [ "ex-kmip-10.cpp", "kmip_example10_ex_kmip_10_cpp.html", null ],
    [ "p6Loader Examples", "p6loader-examples.html", [
      [ "Examples", "p6loader-examples.html#loader-examples", null ]
    ] ],
    [ "Basic example of loading a component library", "loader-ex-loader.html", null ],
    [ "p6api.cpp", "loader-p6api.html", null ],
    [ "JSN Reference", "p6json.html", [
      [ "Introduction", "p6json.html#p6rjson_intro", [
        [ "JSON Parser, XPATH, and XSLT", "p6json.html#p6rjson_sax", null ],
        [ "Includes", "p6json.html#p6rjson_includes", null ],
        [ "Interfaces", "p6json.html#p6rjson_interfaces", null ],
        [ "The Lifetime of P6JSONSTRING pointers", "p6json.html#p6rjson_lifetime", null ],
        [ "A Default Implementation of p6IJSONErrorHandler", "p6json.html#p6rjson_default", null ]
      ] ]
    ] ],
    [ "JSON Parser Examples", "json_examples.html", [
      [ "JSON Parser Examples", "json_examples.html#json_ex_into", null ]
    ] ],
    [ "JSON Example 1 - Verifying JSON Data", "json_example1.html", null ],
    [ "ex-json-1.cpp", "json_example1_ex_json_1_cpp.html", null ],
    [ "ccontenthandler.h", "json_example1_ccontenthandler_h.html", null ],
    [ "ccontenthandler.cpp", "json_example1_ccontenthandler_cpp.html", null ],
    [ "JSON Example 2 - How to detect errors", "json_example2.html", null ],
    [ "ex-json-2.cpp", "json_example2_ex_json_2_cpp.html", null ],
    [ "ccontenthandler.h", "json_example2_ccontenthandler_h.html", null ],
    [ "ccontenthandler.cpp", "json_example2_ccontenthandler_cpp.html", null ],
    [ "cerrorhandler.h", "json_example2_cerrorhandler_h.html", null ],
    [ "cerrorhandler.cpp", "json_example2_cerrorhandler_cpp.html", null ],
    [ "JSON Example 3 - The Bare Minimum", "json_example3.html", null ],
    [ "ex-json3.cpp", "json_example3_ex_json3_cpp.html", null ],
    [ "ccontenthandler.cpp", "json_example3_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "json_example3_ccontenthandler_h.html", null ],
    [ "SAX2 Reference", "p6sax2.html", [
      [ "Introduction", "p6sax2.html#p6rsax2_intro", [
        [ "References", "p6sax2.html#p6rsax2_refs", null ],
        [ "Includes", "p6sax2.html#p6rsax2_includes", null ],
        [ "Interfaces", "p6sax2.html#p6rsax2_interfaces", null ],
        [ "Differences between the Java SAX2 Interface and P6R's C++ Interface", "p6sax2.html#p6rsax2_difs", null ],
        [ "The Lifetime of P6SAX2STRING pointers", "p6sax2.html#p6rsax2_lifetime", null ],
        [ "Example of using XML parser", "p6sax2.html#p6rsax2_examples", null ],
        [ "A Default Implementation of p6ISAX2ErrorHandler", "p6sax2.html#p6rsax2_default", null ]
      ] ]
    ] ],
    [ "SAX2 Examples", "sax2_examples.html", [
      [ "SAX2 Examples", "sax2_examples.html#sax2_ex_into", null ]
    ] ],
    [ "SAX2 Example 1 - Set features and content handlers", "sax2_example1.html", null ],
    [ "ex-sax2-1.cpp", "sax2_example1_ex_sax2_1_cpp.html", null ],
    [ "ccontenthandler.cpp", "sax2_example1_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "sax2_example1_ccontenthandler_h.html", null ],
    [ "cerrorhandler.cpp", "sax2_example1_cerrorhandler_cpp.html", null ],
    [ "cerrorhandler.h", "sax2_example1_cerrorhandler_h.html", null ],
    [ "SAX2 Example 2 - Streaming Interface", "sax2_example2.html", null ],
    [ "ex-sax2-2.cpp", "sax2_example2_ex_sax2_2_cpp.html", null ],
    [ "ccontenthandler.cpp", "sax2_example2_ccontenthandler_cpp.html", null ],
    [ "ccontenthandler.h", "sax2_example2_ccontenthandler_h.html", null ],
    [ "XPath 2.0 and DOM Tree Reference", "p6xpath.html", [
      [ "Introduction", "p6xpath.html#p6rxpath_intro", [
        [ "References", "p6xpath.html#p6rxpath_refs", null ],
        [ "Includes", "p6xpath.html#p6rxpath_includes", null ],
        [ "Interfaces", "p6xpath.html#p6rxpath_interfaces", null ],
        [ "JSON and JsonML Limitiations", "p6xpath.html#p6xpath_json", null ],
        [ "Collations", "p6xpath.html#p6rxpath_collate", null ],
        [ "Extensions to Existing XPath Functions", "p6xpath.html#p6rxpath_ext", null ],
        [ "P6R's Functions Not Yet Implemented", "p6xpath.html#p6rxpath_not", null ],
        [ "P6R's Extension Functions", "p6xpath.html#p6rxpath_extfunc", null ]
      ] ]
    ] ],
    [ "DOM & XPath 2.0 Examples", "dom_examples.html", [
      [ "DOM & XPath 2.0 Examples", "dom_examples.html#dom_ex_into", null ]
    ] ],
    [ "DOM/Xpath Example 1 - DOM & XPath 2.0", "dom_example1.html", null ],
    [ "ex-dom-1.cpp", "dom_example1_ex_dom_1_cpp.html", null ],
    [ "DOM/Xpath Example 2 - Manual Generation of XML, JSON and JsonML", "dom_example2.html", null ],
    [ "ex-dom-2.cpp", "dom_example2_ex_dom_2_cpp.html", null ],
    [ "DOM/Xpath Example 3 - Advanced Sorting Fetaures of p6IDOMNodeset", "dom_example3.html", null ],
    [ "ex-dom-3.cpp", "dom_example3_ex_dom_3_cpp.html", null ],
    [ "DOM/Xpath Example 4 - Namespaces & XPath 2.0", "dom_example4.html", null ],
    [ "ex-dom-4.cpp", "dom_example4_ex_dom_4_cpp.html", null ],
    [ "namespaces.h", "dom_example4_namespaces_h.html", null ],
    [ "namespaces.cpp", "dom_example4_namespaces_cpp.html", null ],
    [ "DOM/Xpath Example 5 - JsonML with DOM and XPath 2.0", "dom_example5.html", null ],
    [ "ex-dom-5.cpp", "dom_example5_ex_dom_5_cpp.html", null ],
    [ "XSLT 2.0 Implementation", "p6xslt.html", [
      [ "Introduction", "p6xslt.html#p6rxslt_intro", [
        [ "XSLT References", "p6xslt.html#p6rxslt_refs", null ],
        [ "Includes", "p6xslt.html#p6rxslt_includes", null ],
        [ "Interfaces", "p6xslt.html#p6rxslt_interfaces", null ],
        [ "JSON and JsonML Support", "p6xslt.html#p6rxslt_json", null ],
        [ "Performance Considerations", "p6xslt.html#p6rxslt_perf", null ],
        [ "Compiled Templates and Multiple Threads", "p6xslt.html#p6rxslt_compile", [
          [ "XSLT Elements and Functions Not Yet Implemented", "p6xslt.html#p6rxslt_notyet", null ],
          [ "Saxon XSLT Element Extensions", "p6xslt.html#saxon_ext", null ]
        ] ]
      ] ],
      [ "Attribute Value Templates", "p6xslt.html#p6rxslt_value", [
        [ "How We Encode QNames", "p6xslt.html#p6rxslt_qnames", null ],
        [ "Other Differences", "p6xslt.html#p6rxslt_diffs", null ]
      ] ]
    ] ],
    [ "XSLT Examples", "xslt_examples.html", [
      [ "XSLT Examples", "xslt_examples.html#xslt_ex_into", null ]
    ] ],
    [ "XSLT Example 1 - The bare minimum", "xslt_example1.html", null ],
    [ "ex-xslt1.cpp", "xslt_example1_ex_xslt1_cpp.html", null ],
    [ "filestream.h", "xslt_example1_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example1_filestream_cpp.html", null ],
    [ "XSLT Example 2 - Using JSON", "xslt_example2.html", null ],
    [ "ex-xslt2.cpp", "xslt_example2_ex_xslt2_cpp.html", null ],
    [ "filestream.h", "xslt_example2_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example2_filestream_cpp.html", null ],
    [ "XSLT Example 3 - Exending Functionality with XPath 2.0", "xslt_example3.html", null ],
    [ "ex-xslt3.cpp", "xslt_example3_ex_xslt3_cpp.html", null ],
    [ "filestream.h", "xslt_example3_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example3_filestream_cpp.html", null ],
    [ "cxpathextend.h", "xslt_example3_cxpathextend_h.html", null ],
    [ "cxpathextend.cpp", "xslt_example3_cxpathextend_cpp.html", null ],
    [ "embeddedxml.xsl", "xslt_example3_embeddedxml_xsl.html", null ],
    [ "XSLT Example 4 - Character Maps", "xslt_example4.html", null ],
    [ "ex-xslt4.cpp", "xslt_example4_ex_xslt4_cpp.html", null ],
    [ "filestream.h", "xslt_example4_filestream_h.html", null ],
    [ "filestream.cpp", "xslt_example4_filestream_cpp.html", null ],
    [ "RGX Reference Guide", "p6wregex.html", [
      [ "Introduction", "p6wregex.html#p6regex_intro", [
        [ "References", "p6wregex.html#p6regex_refs", null ],
        [ "Includes", "p6wregex.html#p6regex_includes", null ],
        [ "Interfaces", "p6wregex.html#p6regex_interfaces", null ],
        [ "Perl Regular Expression Support", "p6wregex.html#p6regex_perl", null ],
        [ "Mapping from Perl to RGX's API", "p6wregex.html#p6regex_mapping", null ],
        [ "Egrep Regular Expression Support", "p6wregex.html#p6regex_egrep", null ],
        [ "What is special about our Regex Engine", "p6wregex.html#p6regex_special", null ],
        [ "Usage Tips", "p6wregex.html#p6regex_tips", null ],
        [ "Examples", "p6wregex.html#p6regex_examples", null ]
      ] ]
    ] ],
    [ "Example 1 - Split & Explode", "regex_example1.html", null ],
    [ "Example 2 - Three ways to do replace", "regex_example2.html", null ],
    [ "Example 3 - Narrow Examples Including Split and Explode", "regex_example3.html", [
      [ "Simple examples illustrating counting, capture, split and explode", "regex_example3.html#regex_example3_sec1", null ]
    ] ],
    [ "Example 4 - Wide Examples", "regex_example4.html", null ],
    [ "Example 5 - EGREP Style Regex", "regex_example5.html", null ],
    [ "Example 6 - Look-Ahead and Look-Behind", "regex_example6.html", null ],
    [ "CConsoleStream", "regex_cconsolestream.html", [
      [ "Introduction", "regex_cconsolestream.html#regex_cconsolestream_intro", null ]
    ] ],
    [ "Example 7 - Multiple Matches", "regex_example7.html", [
      [ "Introduction", "regex_example7.html#regex_example7_intro", [
        [ "Demonstrates", "regex_example7.html#regex_example7_demonstrates", null ],
        [ ".cpp ex-regex-7.cpp", "regex_example7.html#regex_example7_ex-regex-7", null ]
      ] ]
    ] ],
    [ "Networking APIs", "net.html", null ],
    [ "Asynchronous UDP I/O Engine", "net_udpeng.html", null ],
    [ "Database connector object", "p6dbc.html", [
      [ "Introduction", "p6dbc.html#p6rdbc_intro", [
        [ "Includes", "p6dbc.html#p6rdbc_includes", null ],
        [ "Interfaces", "p6dbc.html#p6rdbc_interfaces", null ],
        [ "Postgres and standard SQL", "p6dbc.html#p6rdbc_compatibility", null ],
        [ "How to add more databases", "p6dbc.html#p6rdbc_plugin", null ],
        [ "Signning Databases", "p6dbc.html#p6rdbc_sign", null ]
      ] ]
    ] ],
    [ "The P6R Component Object Model", "base_com.html", [
      [ "Introduction", "base_com.html#base_com_intro", null ],
      [ "P6COM Component Object Rules", "base_com.html#base_com_rules", null ],
      [ "Rules for designing binary compatible interfaces.", "base_com.html#base_com_binif", null ]
    ] ],
    [ "What is [p6]COM", "base_p6rcom_whatis.html", [
      [ "Introduction", "base_p6rcom_whatis.html#base_p6rcom_intro", [
        [ "Resource Management", "base_p6rcom_whatis.html#base_p6rcom_refcount", null ],
        [ "Runtime Polymorphism", "base_p6rcom_whatis.html#base_p6rcom_poly", null ],
        [ "Dynamic Linking", "base_p6rcom_whatis.html#base_p6rcom_dynalink", null ],
        [ "Encapsulation", "base_p6rcom_whatis.html#base_p6rcom_encap", null ]
      ] ]
    ] ],
    [ "P6COM Helpers", "base_p6com_helpers.html", null ],
    [ "P6 Error Codes", "errorcodes.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespace Members", "namespacemembers.html", [
      [ "All", "namespacemembers.html", "namespacemembers_dup" ],
      [ "Functions", "namespacemembers_func.html", null ],
      [ "Variables", "namespacemembers_vars.html", "namespacemembers_vars" ],
      [ "Typedefs", "namespacemembers_type.html", null ],
      [ "Enumerations", "namespacemembers_enum.html", null ],
      [ "Enumerator", "namespacemembers_eval.html", "namespacemembers_eval" ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"annotated.html",
"functions_func_0x7e.html",
"group__type__definitions_ga1ecf639b685cece146140906c2c6888d.html#gga1ecf639b685cece146140906c2c6888daa7a636dc5e65da9a3d52564505913f3c",
"group__type__definitions_ga8b27971c61a6641ebeabf0705326a84a.html#ga8b27971c61a6641ebeabf0705326a84a",
"kmip_example6_ex_kmip_6_cpp.html",
"p6cryptokey_8h.html#a00c639ee5b173a627b12ab500af90fb3a2cce3e653e038bc825f6431b10073e79",
"p6err_8h.html#a44b111a98de6c3807b5fca68d04bdc0f",
"p6kmip_8h.html#a031c5297f6bb6a99b232a987b5ac0162",
"p6kmip_8h.html#a7590d35d7baf02da49d89361e36c3e34",
"p6kmip_8h.html#af0245e61e25a0e5e8dc8e9f81586aa3b",
"p6net_8h.html#ac77001dfc64965736b7453d78e0d3cff",
"p6types_8h.html#ga14b945d1e926038e080f544c0ac47506",
"p6types_8h.html#gga1ecf639b685cece146140906c2c6888da44f333cc655718892c54ef1d99f455ea",
"struct_p6_r_1_1_p6_c_r_y_p_t_o_k_e_y_i_n_f_o_a018ebb83d23e536f7c4c0d4f480cff34.html#a018ebb83d23e536f7c4c0d4f480cff34",
"struct_p6_r_1_1_p6_k_m_i_p___d_e_r_i_v_e_p_a_r_a_m_s_ac8403bfcb406314be26f0ba0c89c4c7b.html#ac8403bfcb406314be26f0ba0c89c4c7b",
"struct_p6_r_1_1_p6_k_m_i_p___p_r_e_f_a509c21fd1c664e5b2f104a1f71ee65f1.html#a509c21fd1c664e5b2f104a1f71ee65f1",
"struct_p6_r_1_1_p6_x_p_a_t_h___a_t_o_m_i_z_e_d_a1424ecf0dc90829314fe88bd38e9235e.html#a1424ecf0dc90829314fe88bd38e9235e",
"struct_p6_r_1_1p6_i_d_h_key_exchange_a2296e487d177fa45e0cd2f7812f8524f.html#a2296e487d177fa45e0cd2f7812f8524f",
"struct_p6_r_1_1p6_i_enum_w_strings.html#a2c045b3b63dc012c7ce5661bfb156c5d",
"struct_p6_r_1_1p6_i_io_buffer_factory.html#ab9e42ac514def0866892a1345cdeb01e",
"struct_p6_r_1_1p6_i_k_m_i_p_response_a0fd2b5cc53c675e2d32031ebab656830.html#a0fd2b5cc53c675e2d32031ebab656830",
"struct_p6_r_1_1p6_i_monitor_a41dc4c69f29b237e5ad339e34be51010.html#a41dc4c69f29b237e5ad339e34be51010",
"struct_p6_r_1_1p6_i_safe_string_a2ebbd84b52cd6286386cd0b09ca7ea9e.html#a2ebbd84b52cd6286386cd0b09ca7ea9e",
"struct_p6_r_1_1p6_i_unbuffered_file_addf9e62d32c976ee3403497ecebe3bc1.html#addf9e62d32c976ee3403497ecebe3bc1",
"struct_p6_r_1_1p6_i_x_s_l_t_compiled.html#a2c045b3b63dc012c7ce5661bfb156c5d"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&nbsp;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

